'****************************************************************
'*  Name    : SM1_Scheduler01.inc                               *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 05/06/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************

'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'
'###############################################################################
'### STATE MACHINE 1 SCHEDULER IN ##############################################
    $ifndef _SM1_Scheduler00Inc_
    $define _SM1_Scheduler00Inc_ 
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim SM2TaskLoop As LVSByte3
' Define the Symbols used:

'*******************************************************************************
'* Name    : State Machine 2 Tasks Switcher                                                          
'* Purpose : Loading a Task from the buffer.                   
'* Notes   :                                         
'===============================================================================
SM2_TasksSwitcher:
'===============================================================================
    If F_SM2_SuspendAllTasks = 0 Then
        '-----------------------------------------------------------------------
        SM2TaskLoop = 0     ' Always read the Task0 first (highest priority).
        Repeat
            SM2StateIndex = SM2Task[SM2TaskLoop]  ' Read any Task.
            If SM2StateIndex < 255 Then           ' Did This Task valid?
                SM2Task[SM2TaskLoop] = 255    ' YES, this task is valid, Read Task done. Delete the task.
                GoTo StartStateMachine2       ' Go to SM2 Scheduler Running this Task.
            EndIf
            Inc SM2TaskLoop
        Until SM2TaskLoop = SM2TasksBufferLenght
        '-----------------------------------------------------------------------
    EndIf
    ' No Task in the Buffer.
'===============================================================================
' Return from State Machine2
ReturnStateMachine2:
    $ifdef _CheckADCSystem_
    SM2StateIndexOld = SM2StateIndex
    $endif
'*******************************************************************************
'* Name    : State Machine 1 Scheduler                                                          
'* Purpose : Running the code of All modules.                   
'* Notes   : Do not forget update the SM1_LABELS_LIST.                                            
'===============================================================================
    ' Running the Module Delay. The F_SM1VirtualDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _EnableSM1VDelay_
    If F_SM1VirtualDelay = 1 Then
        GoTo StartStateMachine1  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
    '===========================================================================
    ' Update the LABELS when you add a new State Machine Module.
    SM1_LABELS_LIST
    '===========================================================================
    ' Debug section. StateIndex is OUT of RANGE.
    $ifdef _EnableTerminal_
    HRSOut "SM1 STATE OUT OF RANGE: ", Dec StateIndex,CR,LF
    DelayMS 1000
    $endif
SM1OVERFLOW:
    SMFlags = 0
    SMTimingFlags1 = 0
    SMTimingFlags2 = 0
    SM_UserFunctionFlags = 0
    ' ERROR in States Machine Variable Range. Reset the States Machine. 
    GoTo StateMachineInit  ' Equivalent of Reset On stack overflow. 
'###############################################################################
'### STATE MACHINE 1 SCHEDULER END #############################################
$endif
'###############################################################################

