'****************************************************************
'*  Name    : SM2_Scheduler01.inc                               *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 05/06/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'
'###############################################################################
'#### TASKS SWITCHER SYSTEM IN #################################################
'###############################################################################
' The Main code Start Here:

$ifndef _SM2_Scheduler00Inc_
$define _SM2_Scheduler00Inc_ 
'*******************************************************************************
'* Name    : StartStateMachine2                                                *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   :                                                                   *
'*******************************************************************************
StartStateMachine2:
'*******************************************************************************
'* Name    : STATE MACHINE 2 Tasks Switcher        
'* Purpose : Run every task written in the buffer.                                                      
'* Notes   : Running SM2Task#0 to SM2Task#N                                                            
'*         : SM2StateIndex is the priority task and it does not need the Tasks Switcher.
'*         : Do not forget update the SM2_LABELS_LIST.  
'===============================================================================
' Define the Global variables used in this state:
       
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
    ' SM2Scheduler:
    ' Update the LABELS when you add a new States Machine Module.
    SM2_LABELS_LIST
'===============================================================================
    ' Debug section. StateIndex2 is OUT of RANGE.
    $ifdef _EnableTerminal_
    HRSOut "SM2 STATE OUT OF RANGE: ", Dec SM2StateIndex,13,10
    DelayMS 1000
    $endif
    Set SM2Task ' In case of error then clear all buffer Tasks.
    F_SM2VirtualDelay = 0
    F_SM2DelayedTask = 0
    ' ERROR in States Machine2 Variable Range. Reset the States Machine2. 
    GoTo SM1OVERFLOW    ' Equivalent of Reset On stack overflow. 
'###############################################################################
$endif
'###############################################################################
'#### TASKS SWITCHER SYSTEM END ################################################
'###############################################################################


